using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Data;
using System.IO;

namespace PerformanceTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class PerformanceTest : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbFileName;
		private System.Windows.Forms.Label lbFileName;
		private System.Windows.Forms.Label lbNumberOfJobs;
		private System.Windows.Forms.TextBox tbNumberOfJobs;
		private System.Windows.Forms.Button btTest;
		private System.Windows.Forms.Button btCancel;
		private System.Windows.Forms.Label lbUsername;
		private System.Windows.Forms.TextBox tbUsername;
		private System.Windows.Forms.Label lbPassword;
		private System.Windows.Forms.TextBox tbPassword;
		private System.Windows.Forms.GroupBox gbUserSettings;
		private System.Windows.Forms.GroupBox gbSettings;
		private System.Windows.Forms.GroupBox gbStatus;
		private System.Windows.Forms.TextBox tbStatus;
		private System.Windows.Forms.ProgressBar progressBar;


		private de.discourse.was.DCLExperimentService experimentService;
		private de.discourse.was1.DCLTicketServer ticketServer;
		private Thread testThread;

		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PerformanceTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			experimentService = new de.discourse.was.DCLExperimentService();
			ticketServer = new de.discourse.was1.DCLTicketServer();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tbFileName = new System.Windows.Forms.TextBox();
			this.lbFileName = new System.Windows.Forms.Label();
			this.lbNumberOfJobs = new System.Windows.Forms.Label();
			this.tbNumberOfJobs = new System.Windows.Forms.TextBox();
			this.btTest = new System.Windows.Forms.Button();
			this.btCancel = new System.Windows.Forms.Button();
			this.lbUsername = new System.Windows.Forms.Label();
			this.tbUsername = new System.Windows.Forms.TextBox();
			this.lbPassword = new System.Windows.Forms.Label();
			this.tbPassword = new System.Windows.Forms.TextBox();
			this.gbUserSettings = new System.Windows.Forms.GroupBox();
			this.gbSettings = new System.Windows.Forms.GroupBox();
			this.gbStatus = new System.Windows.Forms.GroupBox();
			this.tbStatus = new System.Windows.Forms.TextBox();
			this.progressBar = new System.Windows.Forms.ProgressBar();
			this.gbStatus.SuspendLayout();
			this.SuspendLayout();
			// 
			// tbFileName
			// 
			this.tbFileName.Location = new System.Drawing.Point(104, 136);
			this.tbFileName.Name = "tbFileName";
			this.tbFileName.Size = new System.Drawing.Size(176, 20);
			this.tbFileName.TabIndex = 0;
			this.tbFileName.Text = "result.dat";
			// 
			// lbFileName
			// 
			this.lbFileName.Location = new System.Drawing.Point(16, 136);
			this.lbFileName.Name = "lbFileName";
			this.lbFileName.Size = new System.Drawing.Size(64, 23);
			this.lbFileName.TabIndex = 1;
			this.lbFileName.Text = "File Name";
			// 
			// lbNumberOfJobs
			// 
			this.lbNumberOfJobs.Location = new System.Drawing.Point(16, 168);
			this.lbNumberOfJobs.Name = "lbNumberOfJobs";
			this.lbNumberOfJobs.Size = new System.Drawing.Size(88, 23);
			this.lbNumberOfJobs.TabIndex = 3;
			this.lbNumberOfJobs.Text = "Number of jobs";
			// 
			// tbNumberOfJobs
			// 
			this.tbNumberOfJobs.Location = new System.Drawing.Point(104, 168);
			this.tbNumberOfJobs.Name = "tbNumberOfJobs";
			this.tbNumberOfJobs.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.tbNumberOfJobs.Size = new System.Drawing.Size(40, 20);
			this.tbNumberOfJobs.TabIndex = 2;
			this.tbNumberOfJobs.Text = "";
			// 
			// btTest
			// 
			this.btTest.Location = new System.Drawing.Point(104, 320);
			this.btTest.Name = "btTest";
			this.btTest.TabIndex = 4;
			this.btTest.Text = "Test";
			this.btTest.Click += new System.EventHandler(this.btTest_Click);
			// 
			// btCancel
			// 
			this.btCancel.Location = new System.Drawing.Point(208, 320);
			this.btCancel.Name = "btCancel";
			this.btCancel.TabIndex = 5;
			this.btCancel.Text = "Cancel";
			this.btCancel.Click += new System.EventHandler(this.btCancel_Click);
			// 
			// lbUsername
			// 
			this.lbUsername.Location = new System.Drawing.Point(16, 32);
			this.lbUsername.Name = "lbUsername";
			this.lbUsername.Size = new System.Drawing.Size(64, 23);
			this.lbUsername.TabIndex = 7;
			this.lbUsername.Text = "Username";
			// 
			// tbUsername
			// 
			this.tbUsername.Location = new System.Drawing.Point(104, 32);
			this.tbUsername.Name = "tbUsername";
			this.tbUsername.Size = new System.Drawing.Size(176, 20);
			this.tbUsername.TabIndex = 6;
			this.tbUsername.Text = "";
			// 
			// lbPassword
			// 
			this.lbPassword.Location = new System.Drawing.Point(16, 64);
			this.lbPassword.Name = "lbPassword";
			this.lbPassword.Size = new System.Drawing.Size(64, 23);
			this.lbPassword.TabIndex = 9;
			this.lbPassword.Text = "Password";
			// 
			// tbPassword
			// 
			this.tbPassword.Location = new System.Drawing.Point(104, 64);
			this.tbPassword.Name = "tbPassword";
			this.tbPassword.PasswordChar = '*';
			this.tbPassword.Size = new System.Drawing.Size(176, 20);
			this.tbPassword.TabIndex = 8;
			this.tbPassword.Text = "";
			// 
			// gbUserSettings
			// 
			this.gbUserSettings.Location = new System.Drawing.Point(8, 8);
			this.gbUserSettings.Name = "gbUserSettings";
			this.gbUserSettings.Size = new System.Drawing.Size(280, 88);
			this.gbUserSettings.TabIndex = 10;
			this.gbUserSettings.TabStop = false;
			this.gbUserSettings.Text = "User Settings";
			// 
			// gbSettings
			// 
			this.gbSettings.Location = new System.Drawing.Point(8, 112);
			this.gbSettings.Name = "gbSettings";
			this.gbSettings.Size = new System.Drawing.Size(280, 88);
			this.gbSettings.TabIndex = 11;
			this.gbSettings.TabStop = false;
			this.gbSettings.Text = "Settings";
			// 
			// gbStatus
			// 
			this.gbStatus.Controls.Add(this.progressBar);
			this.gbStatus.Controls.Add(this.tbStatus);
			this.gbStatus.Location = new System.Drawing.Point(8, 216);
			this.gbStatus.Name = "gbStatus";
			this.gbStatus.Size = new System.Drawing.Size(280, 88);
			this.gbStatus.TabIndex = 12;
			this.gbStatus.TabStop = false;
			this.gbStatus.Text = "Status";
			// 
			// tbStatus
			// 
			this.tbStatus.Location = new System.Drawing.Point(8, 24);
			this.tbStatus.Multiline = true;
			this.tbStatus.Name = "tbStatus";
			this.tbStatus.ReadOnly = true;
			this.tbStatus.Size = new System.Drawing.Size(264, 24);
			this.tbStatus.TabIndex = 0;
			this.tbStatus.Text = "";
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(8, 64);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(264, 8);
			this.progressBar.TabIndex = 1;
			// 
			// PerformanceTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(296, 349);
			this.Controls.Add(this.gbStatus);
			this.Controls.Add(this.lbPassword);
			this.Controls.Add(this.tbPassword);
			this.Controls.Add(this.lbUsername);
			this.Controls.Add(this.tbUsername);
			this.Controls.Add(this.btCancel);
			this.Controls.Add(this.btTest);
			this.Controls.Add(this.lbNumberOfJobs);
			this.Controls.Add(this.tbNumberOfJobs);
			this.Controls.Add(this.lbFileName);
			this.Controls.Add(this.tbFileName);
			this.Controls.Add(this.gbUserSettings);
			this.Controls.Add(this.gbSettings);
			this.HelpButton = true;
			this.Name = "PerformanceTest";
			this.Text = "DCL Performance Test";
			this.gbStatus.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new PerformanceTest());
		}

		private void btTest_Click(object sender, System.EventArgs e)
		{
			try
			{
				testThread.Abort();
			}
			catch{}
			try
			{
				testThread = new Thread(new ThreadStart(test));
				testThread.Start();
			}
			catch(ThreadAbortException){}
		}

		private void btCancel_Click(object sender, System.EventArgs e)
		{			
			try
			{
				testThread.Abort();
			}
			catch{}
			Application.Exit();
		}

		private void test()
		{
			if (!validate())
			{
				return;
			}
			
			tbStatus.Text = "Prepare for testing...";
			
			int iterations = Convert.ToInt32(tbNumberOfJobs.Text);
			
			Int64 time = 0;
			
			bool viewAll;
			string[] ticketList = null;
			
			try
			{
				ticketList = ticketServer.GetTicketList(tbUsername.Text, tbPassword.Text, out viewAll);				
			}
			catch
			{
				tbStatus.Text = "Connection to DCL failed";
				return;
			}


			string ticket = ticketList[0];

			if (ticket == "S_ERROR_INVALID_LOGIN")
			{
				tbStatus.Text = "Invalid username or password.";
				return;
			}

			if (ticket == "S_ERROR_NOTHING_FOUND")
			{
				tbStatus.Text = "No jobs found.";
				return;
			}

			progressBar.Minimum = 0;
			progressBar.Maximum	= iterations;
            progressBar.Value = 0;            
			
			StreamWriter SW = null;
			try
			{
				SW = File.CreateText(tbFileName.Text);
			}
			catch
			{
				tbStatus.Text = "Invaild file name";
				return;
			}
			
			tbStatus.Text = "Testing...";

			for (int i = 0; i < iterations ; i++)
			{
				time = Environment.TickCount;

				experimentService.GetExperimentTypeofTicket(ticket);
				experimentService.GetExperimentStatus(ticket);
				ticketServer.GetUsageStart(ticket);

				time = Environment.TickCount - time;
                
				SW.WriteLine(time.ToString());

				progressBar.Increment(1);
			}
			SW.Close();
			tbStatus.Text = "Test finished";
		}

		private bool validate()
		{
			if (tbUsername.Text.Length == 0)
			{
				tbStatus.Text = "Please enter a username!";
				return false;
			}

			if (tbPassword.Text.Length == 0)
			{
				tbStatus.Text = "Please enter a password!";
				return false;
			}

			if (tbFileName.Text.Length == 0)
			{
				tbStatus.Text = "Please enter a file name!";
				return false;
			}
			
			if (tbNumberOfJobs.Text.Length == 0)
			{
				tbStatus.Text = "Please enter a number!";
				return false;
			}
			
			if (tbNumberOfJobs.Text.Length > 5)
			{
				tbStatus.Text = "Number to large!";
				return false;
			}
			
			try
			{
				int iterations = Convert.ToInt32(tbNumberOfJobs.Text);
				if (iterations < 1)
				{
					tbStatus.Text = "Number must be greater than 0!";
				}
			}
			catch (ArgumentNullException)
			{
				tbStatus.Text = "Please enter a number!";
				return false;
			}
			catch (FormatException)
			{
				tbStatus.Text = "Please enter a number!";
				return false;
			}
	
			return true;
		}
	}
}
